// CustomSlider.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "CustomSlider.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomSlider

CCustomSlider::CCustomSlider()
{
	m_crBkColor = ::GetSysColor(COLOR_3DFACE); // Initializing the Background Color to the system face color.
	m_crTextColor = RGB(0,0,0); // Initializing the text to Black
	m_brBkgnd.CreateSolidBrush(m_crBkColor); // Create the Brush Color for the Background.
}

CCustomSlider::~CCustomSlider()
{
}


BEGIN_MESSAGE_MAP(CCustomSlider, CSliderCtrl)
	//{{AFX_MSG_MAP(CCustomSlider)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomSlider message handlers

void CCustomSlider::SetBkColor(COLORREF crColor)
{
	//m_Brush.CreateSolidBrush(crColor);
    //m_Pen.CreatePen(PS_SOLID, 1, RGB(128,128,128));
}

void CCustomSlider::SetTextColor(COLORREF crColor)
{
	m_Brush.CreateSolidBrush(crColor);
    m_Pen.CreatePen(PS_SOLID, 1, RGB(128,128,128));
}

void CCustomSlider::CreateFromControl(CWnd *pParentWnd,UINT nID)
{
	BOOL result = FALSE;

	ASSERT(pParentWnd != NULL);

	CWnd *control = pParentWnd->GetDlgItem(nID);

	if (control != NULL) {

		// get control location

		CRect		rect;

		control->GetWindowRect(&rect);
		pParentWnd->ScreenToClient(&rect);

		// destroy control, since the browser will take its place

		control->DestroyWindow();

		// create browser

		result = Create((WS_CHILD | WS_VISIBLE),
		                rect,
						pParentWnd,
						nID);

	}

	return;
}

void CCustomSlider::OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMCUSTOMDRAW nmcd = *(LPNMCUSTOMDRAW)pNMHDR;

	if(nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
		return;
    }

	if(nmcd.dwDrawStage == CDDS_ITEMPREPAINT && nmcd.dwItemSpec == TBCD_CHANNEL)
	{
		CDC* pDC = CDC::FromHandle( nmcd.hdc );
		CRect rect;
		GetClientRect(&rect);
		pDC->FillSolidRect(&rect, OUR_BGCOLOR);  // some color

		RECT rrc = {nmcd.rc.left+1, nmcd.rc.top+1, nmcd.rc.right-1, 
                                nmcd.rc.bottom-1};
        pDC->Draw3dRect( &rrc, RGB(30,82,184), RGB(70,122,224) );

		/*{
			for(int i = 0; i < (signed)GetNumTics() - 2; i++)
			{
				DWORD *tics = GetTicArray();
				int x = GetTicPos(tics[i]);
				RECT rrc = {rect.left + x, rect.top+1, rect.left + x+2, 
                                rect.bottom-1};
				 pDC->Draw3dRect( &rrc, RGB(0, 0, 0), RGB(20, 20, 20) );
			}
		}*/

		*pResult = CDRF_SKIPDEFAULT;
		return;
	}

	if(nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
    {
        if(nmcd.dwItemSpec == TBCD_THUMB)
        {
            CDC* pDC = CDC::FromHandle( nmcd.hdc );
            pDC->SelectObject( m_Brush );
            pDC->SelectObject( m_Pen );
            pDC->Ellipse( &(nmcd.rc) );

			int xx, yy, dx, dy, cx, cy;
            xx = nmcd.rc.left;
            yy = nmcd.rc.top;
            dx = 2;
            dy = 2;
            cx = nmcd.rc.right - xx - 1;
            cy = nmcd.rc.bottom - yy - 1;
            POINT pts[8] = { {xx+dx, yy}, 
                {xx, yy+dy},
                {xx, yy+cy-dy}, 
                {xx+dx, yy+cy},
                {xx+cx-dx, yy+cy}, 
                {xx+cx, yy+cy-dy}, 
                {xx+cx, yy+dy}, 
                {xx+cx-dx, yy} };

            pDC->Polygon( pts, 8 );  // diamond shape

            //pDC->RestoreDC( iSaveDC );
            pDC->Detach();

            *pResult = CDRF_SKIPDEFAULT;
        }
    }
}
