// EngineDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "EngineDlg.h"
#include "ProgressDlg.h"
#include <algorithm>

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEngineDlg dialog


CEngineDlg::CEngineDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEngineDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEngineDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CEngineDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEngineDlg)
	DDX_Control(pDX, IDC_REMOVEENGINE, m_RemoveEngine);
	DDX_Control(pDX, IDC_ADDENGINE, m_AddEngine);
	DDX_Control(pDX, IDC_ENGINEPREV, m_Prev);
	DDX_Control(pDX, IDC_ENGINELIST2, m_EngineList2);
	DDX_Control(pDX, IDC_ENGINELIST, m_EngineList);
	DDX_Control(pDX, IDC_ENGINENEXT, m_Next);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEngineDlg, CDialog)
	//{{AFX_MSG_MAP(CEngineDlg)
	ON_BN_CLICKED(IDC_ADDENGINE, OnAdd)
	ON_BN_CLICKED(IDC_REMOVEENGINE, OnRemove)
	ON_WM_CLOSE()
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_ENGINENEXT, OnNext)
	ON_BN_CLICKED(IDC_ENGINEPREV, OnPrev)
	ON_COMMAND(ID_ACTION_BACK, OnActionBack)
	ON_COMMAND(ID_ACTION_NEXT, OnActionNext)
	ON_COMMAND(ID_FILE_CHECKUPDATES, OnFileCheckupdates)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_LOG_CLEARLOG, OnLogClearlog)
	ON_COMMAND(ID_LOG_VIEWLOG, OnLogViewlog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEngineDlg message handlers

void CEngineDlg::OnAdd() 
{
	int items[MAX_SITES+MAX_MAN_SITES];
	int count = m_EngineList.GetSelItems(MAX_SITES+MAX_MAN_SITES, items);
	if(count == LB_ERR || count == 0)
		return;

	for(int i = 0; i < count; i++)
	{
		CString text;
		int id, q;
		m_EngineList.GetText(items[i], text);
		id = m_EngineList.GetItemData(items[i]);

		q = m_EngineList2.AddString(text);
		m_EngineList2.SetItemData(q, id);
	}

	for(i = 0; i < count; i++)
	{
		m_EngineList.DeleteString(items[i] - i);
	}
}

void CEngineDlg::OnRemove() 
{	
	int items[MAX_SITES+MAX_MAN_SITES];
	int count = m_EngineList2.GetSelItems(MAX_SITES+MAX_MAN_SITES, items);
	if(count == LB_ERR || count == 0)
		return;

	for(int i = 0; i < count; i++)
	{
		CString text;
		int id, q;
		m_EngineList2.GetText(items[i], text);
		id = m_EngineList2.GetItemData(items[i]);

		q = m_EngineList.AddString(text);
		m_EngineList.SetItemData(q, id);
	}

	for(i = 0; i < count; i++)
	{
		m_EngineList2.DeleteString(items[i] - i);
	}
}

BOOL CEngineDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Set title
	SetWindowText(gProgramName);

	// Tool Tips
	m_ToolTipCtrl.Create(this);
	m_ToolTipCtrl.AddTool(&m_Next, "Next");
	m_ToolTipCtrl.AddTool(&m_Prev, "Back");
	m_ToolTipCtrl.AddTool(&m_AddEngine, "Add Engine");
	m_ToolTipCtrl.AddTool(&m_RemoveEngine, "Remove Engine");
	m_ToolTipCtrl.AddTool(&m_EngineList, "Available Engines");
	m_ToolTipCtrl.AddTool(&m_EngineList2, "Engines you have selected");

	// Menu
	CMenu *menu = GetMenu();
	menu->RemoveMenu(ID_ACTION_VALIDATE, MF_BYCOMMAND);

	//m_EngineList.CreateFromControl(this, IDC_ENGINELIST);
	//m_EngineList2.CreateFromControl(this, IDC_ENGINELIST2);

	// Populate Engine Lists
	int id;
	
	for(int i = 0; i < MAX_SITES; i++)
	{
		if(checkIfEngineIsSelected(i))
		{
			id = m_EngineList2.AddString(gSites[i][0]);
			m_EngineList2.SetItemData(id, i);
		}
		else
		{
			id = m_EngineList.AddString(gSites[i][0]);
			m_EngineList.SetItemData(id, i);
		}
	}

	for(i = 0; i < MAX_MAN_SITES; i++)
	{
		if(checkIfEngineIsSelected(i + MAX_SITES))
		{
			id = m_EngineList2.AddString("* " + CString(gManSites[i][0]));
			m_EngineList2.SetItemData(id, i + MAX_SITES);
		}
		else
		{
			id = m_EngineList.AddString("* " + CString(gManSites[i][0]));
			m_EngineList.SetItemData(id, i + MAX_SITES);
		}
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEngineDlg::OnClose() 
{
	EndDialog(0);
	
	CDialog::OnClose();
}

BOOL CEngineDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, OUR_BGCOLOR);  // some color
	return FALSE;
	
	return CDialog::OnEraseBkgnd(pDC);
}

void CEngineDlg::OnNext() 
{
	if(m_EngineList2.GetCount() == 0)
	{
		MessageBox("Please select at least one engine to use.");
		return;
	}

	UpdateSelectedEngines();

	EndDialog(2);
}

void CEngineDlg::OnPrev() 
{
	UpdateSelectedEngines();
	EndDialog(1);
}

BOOL CEngineDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_ToolTipCtrl.RelayEvent(pMsg);	
	return CDialog::PreTranslateMessage(pMsg);
}

BOOL CEngineDlg::checkIfEngineIsSelected(int id)
{
	if(id < MAX_SITES)
	{
		if(find(gSelectedEngines.begin(), gSelectedEngines.end(), id) == gSelectedEngines.end())
			return FALSE;
		return TRUE;
	}

	if(find(gSelectedManEngines.begin(), gSelectedManEngines.end(), id - MAX_SITES) == gSelectedManEngines.end())
		return FALSE;
	return TRUE;
}

void CEngineDlg::UpdateSelectedEngines()
{
	gSelectedEngines.clear();
	gSelectedManEngines.clear();

	for(int i = 0; i < m_EngineList2.GetCount(); i++)
	{
		int id = m_EngineList2.GetItemData(i);
		if(id < MAX_SITES)
			gSelectedEngines.push_back(id);
		else
			gSelectedManEngines.push_back(id - MAX_SITES);
	}
}

void CEngineDlg::OnActionBack() 
{
	OnPrev();
}

void CEngineDlg::OnActionNext() 
{
	OnNext();
}

void CEngineDlg::OnFileCheckupdates() 
{
	WinExec("AutoUpdater.exe", SW_SHOW);
}

void CEngineDlg::OnFileExit() 
{
	EndDialog(0);
}

void CEngineDlg::OnLogClearlog() 
{
	ClearLog();
}

void CEngineDlg::OnLogViewlog() 
{
	ViewLog();
}
