// FeedDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "FeedDialog.h"
#include "FeedFunctions.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFeedDialog dialog


CFeedDialog::CFeedDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CFeedDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFeedDialog)
	m_FeedDescription = _T("");
	m_FeedTitle = _T("");
	m_FeedURL = _T("");
	m_Country = _T("");
	m_Language = _T("");
	m_WebURL = _T("");
	m_EMail = _T("");
	m_Name = _T("");
	m_Category = _T("");
	//}}AFX_DATA_INIT
}


void CFeedDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFeedDialog)
	DDX_Text(pDX, IDC_FEEDDESC, m_FeedDescription);
	DDV_MaxChars(pDX, m_FeedDescription, 2040);
	DDX_Text(pDX, IDC_FEEDTITLE, m_FeedTitle);
	DDV_MaxChars(pDX, m_FeedTitle, 2040);
	DDX_Text(pDX, IDC_FEEDURL, m_FeedURL);
	DDV_MaxChars(pDX, m_FeedURL, 2040);
	DDX_Text(pDX, IDC_COUNTRY, m_Country);
	DDV_MaxChars(pDX, m_Country, 2040);
	DDX_Text(pDX, IDC_LANGUAGE, m_Language);
	DDV_MaxChars(pDX, m_Language, 2040);
	DDX_Text(pDX, IDC_WEBURL, m_WebURL);
	DDV_MaxChars(pDX, m_WebURL, 2040);
	DDX_Text(pDX, IDC_FEEDEMAIL, m_EMail);
	DDV_MaxChars(pDX, m_EMail, 2040);
	DDX_Text(pDX, IDC_FULLNAME, m_Name);
	DDV_MaxChars(pDX, m_Name, 2040);
	DDX_CBString(pDX, IDC_CATEGORY, m_Category);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFeedDialog, CDialog)
	//{{AFX_MSG_MAP(CFeedDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFeedDialog message handlers

void CFeedDialog::OnCancel() 
{
	EndDialog(1);
}

void CFeedDialog::OnOK() 
{
	FEED feed;

	UpdateData(TRUE);

	if(m_FeedTitle.GetLength() == 0)
	{
		MessageBox("Please enter a title.", "Error");
		GetDlgItem(IDC_FEEDTITLE)->SetFocus();
		return;
	}

	if(m_FeedURL.GetLength() == 0)
	{
		MessageBox("Please enter an URL.", "Error");
		GetDlgItem(IDC_FEEDURL)->SetFocus();
		return;
	}

	if(m_FeedURL.Find("://") == -1 || m_FeedURL.Find(".") == -1)
	{
		MessageBox("Please enter a valid URL, including the http:// or other specifier.", "Error");
		GetDlgItem(IDC_FEEDURL)->SetFocus();
		return;
	}

	if(m_Name.GetLength() == 0)
	{
		MessageBox("Please enter your full name.", "Error");
		GetDlgItem(IDC_FULLNAME)->SetFocus();
		return;
	}

	if(m_Name.Find(" ") == -1)
	{
		MessageBox("Please enter both your first and last name.", "Error");
		GetDlgItem(IDC_FULLNAME)->SetFocus();
		return;
	}

	if(m_EMail.GetLength() == 0)
	{
		MessageBox("Please enter your email.", "Error");
		GetDlgItem(IDC_FEEDEMAIL)->SetFocus();
		return;
	}

	if(m_EMail.Find("@") == -1 || m_EMail.Find(".") == -1)
	{
		MessageBox("Please enter a valid E-Mail address.", "Error");
		GetDlgItem(IDC_FEEDEMAIL)->SetFocus();
		return;
	}

	if(m_Language.GetLength() == 0)
	{
		MessageBox("Please enter a language.", "Error");
		GetDlgItem(IDC_LANGUAGE)->SetFocus();
		return;
	}

	if(m_Country.GetLength() == 0)
	{
		MessageBox("Please enter your country.", "Error");
		GetDlgItem(IDC_COUNTRY)->SetFocus();
		return;
	}

	if(m_FeedURL.Find(' ') != -1)
	{
		MessageBox("Warning! URLs with spaces in them may cause problems with some of the sites.", "Warning", MB_ICONWARNING);
	}

	feed.title = m_FeedTitle;
	feed.url = m_FeedURL;
	feed.description = m_FeedDescription;
	feed.category = m_Category;
	feed.language = m_Language;
	feed.weburl = m_WebURL;
	feed.country = m_Country;
	feed.name = m_Name;
	feed.email = m_EMail;

	gFeeds.push_back(feed);
	gLastFeed = feed;

	SaveFeeds();

	EndDialog(0);
}

void CFeedDialog::SetEditMode(int id)
{
	FEED feed = gFeeds[id];

	editTitle = feed.title.c_str();
	editURL = feed.url.c_str();
	editDescription = feed.description.c_str();
	editWebURL = feed.weburl.c_str();
	editCountry = feed.country.c_str();
	editLanguage = feed.language.c_str();
	editCategory = feed.category.c_str();
	editName = feed.name.c_str();
	editEMail = feed.email.c_str();
}

BOOL CFeedDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_Country = gLastFeed.country.c_str();
	m_Language = gLastFeed.language.c_str();
	m_Name = gLastFeed.name.c_str();
	m_EMail = gLastFeed.email.c_str();
	UpdateData(FALSE);
	
	if(editTitle.GetLength() > 0)
	{
		SetWindowText("Edit Feed");
		m_FeedTitle = editTitle;
		m_FeedURL = editURL;
		m_FeedDescription = editDescription;
		m_WebURL = editWebURL;
		m_Country = editCountry;
		m_Language = editLanguage;
		m_Category = editCategory;
		m_Name = editName;
		m_EMail = editEMail;

		UpdateData(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
