#include "StdAfx.h"
#include "FeedFunctions.h"

using namespace std;

vector < FEED > gFeeds;
vector < FEED > gSelectedFeeds;
vector < int > gSelectedEngines;
vector < int > gSelectedManEngines;
int gDisplayValidation = 0;

FEED gLastFeed;

CString GetTimeStamp()
{
	time_t tim;
	tm *ptr;
	CString str;

	tim = time(NULL);
	ptr = localtime(&tim);
	strftime(str.GetBuffer(1024), 1024, "%c", ptr);
	str.ReleaseBuffer();
	return str;
}

void AddToLog(const char *message)
{
	FILE *fp = fopen("rsslog.txt", "ab");
	if(!fp)
		return;

	fprintf(fp, "[%s] %s", (const char *)GetTimeStamp(), message);

	fclose(fp);
}

void ViewLog()
{
	WinExec("notepad.exe rsslog.txt", SW_SHOW);
}

void ClearLog()
{
	FILE *fp = fopen("rsslog.txt", "w");
	if(fp)
		fclose(fp);
}

void trim_line(char *line)
{
	int len = strlen(line);

	if(line[len - 1] == '\n')
		line[--len] = 0;
	if(line[len - 1] == '\r')
		line[--len] = 0;
}

int LoadFeeds()
{
	FILE *fp = fopen("feeds.txt", "rb");

	if(fp == NULL)
		return -1;

	gFeeds.clear();

	while(true)
	{
		char title[2048], url[2048], description[2048], category[2048], country[2048], weburl[2048];
		char name[2048], email[2048], language[2048];
		FEED feed;

		if(fgets(title, 2044, fp) == NULL)
			break;

		trim_line(title);
		fgets(url, 2044, fp);
		trim_line(url);
		fgets(description, 2044, fp);
		trim_line(description);
		fgets(category, 2044, fp);
		trim_line(category);
		fgets(country, 2044, fp);
		trim_line(country);
		fgets(weburl, 2044, fp);
		trim_line(weburl);
		fgets(name, 2044, fp);
		trim_line(name);
		fgets(email, 2044, fp);
		trim_line(email);
		fgets(language, 2044, fp);
		trim_line(language);

		feed.title = title;
		feed.url = url;
		feed.description = description;
		feed.category = category;
		feed.country = country;
		feed.weburl = weburl;
		feed.name = name;
		feed.email = email;
		feed.language = language;

		gFeeds.push_back(feed);
	}

	fclose(fp);
	return 0;
}

int SaveFeeds()
{
	FILE *fp = fopen("feeds.txt", "wb");

	if(fp == NULL)
		return -1;

	for(vector < FEED >::iterator iter = gFeeds.begin(); iter != gFeeds.end(); ++iter)
	{
		fputs((iter->title + "\n").c_str(), fp);
		fputs((iter->url + "\n").c_str(), fp);
		fputs((iter->description + "\n").c_str(), fp);
		fputs((iter->category + "\n").c_str(), fp);
		fputs((iter->country + "\n").c_str(), fp);
		fputs((iter->weburl + "\n").c_str(), fp);
		fputs((iter->name + "\n").c_str(), fp);
		fputs((iter->email + "\n").c_str(), fp);
		fputs((iter->language + "\n").c_str(), fp);
	}

	fclose(fp);
	return 0;
}