// ManageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "ManageDlg.h"
#include "FeedFunctions.h"
#include "FeedDialog.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CManageDlg dialog


CManageDlg::CManageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManageDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CManageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManageDlg)
	DDX_Control(pDX, IDC_MANAGEPREV, m_Prev);
	DDX_Control(pDX, IDC_MANAGENEXT, m_Next);
	DDX_Control(pDX, IDC_MANAGEEDIT, m_Edit);
	DDX_Control(pDX, IDC_MANAGEDELETE, m_Delete);
	DDX_Control(pDX, IDC_MANAGEADD, m_Add);
	DDX_Control(pDX, IDC_MANAGELIST, m_FeedList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManageDlg, CDialog)
	//{{AFX_MSG_MAP(CManageDlg)
	ON_BN_CLICKED(IDC_MANAGENEXT, OnNext)
	ON_WM_ERASEBKGND()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_MANAGEADD, OnAdd)
	ON_BN_CLICKED(IDC_MANAGEEDIT, OnEdit)
	ON_BN_CLICKED(IDC_MANAGEDELETE, OnDelete)
	ON_NOTIFY(LVN_KEYDOWN, IDC_MANAGELIST, OnKeydownList)
	ON_BN_CLICKED(IDC_MANAGEPREV, OnPrev)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_ACTION_BACK, OnActionBack)
	ON_COMMAND(ID_ACTION_NEXT, OnActionNext)
	ON_COMMAND(ID_FILE_CHECKUPDATES, OnFileCheckupdates)
	ON_COMMAND(ID_LOG_CLEARLOG, OnLogClearlog)
	ON_COMMAND(ID_LOG_VIEWLOG, OnLogViewlog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManageDlg message handlers

void CManageDlg::OnNext() 
{
	EndDialog(2);
}

BOOL CManageDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, OUR_BGCOLOR);  // some color
	return FALSE;
}

BOOL CManageDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Icon
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Set title
	SetWindowText(gProgramName);

	// Tool Tips
	m_ToolTipCtrl.Create(this);
	m_ToolTipCtrl.AddTool(&m_Next, "Next");
	m_ToolTipCtrl.AddTool(&m_Prev, "Prev");
	m_ToolTipCtrl.AddTool(&m_Add, "Add");
	m_ToolTipCtrl.AddTool(&m_Edit, "Edit");
	m_ToolTipCtrl.AddTool(&m_Delete, "Delete");

	// Menu
	CMenu *menu = GetMenu();
	menu->RemoveMenu(ID_ACTION_VALIDATE, MF_BYCOMMAND);

	// Add Columns to List Control
	CRect rect;
	m_FeedList.GetClientRect(&rect);
	int nColInterval = rect.Width()/5;

	m_FeedList.InsertColumn(0, _T("Title"), LVCFMT_LEFT, nColInterval*2);
	m_FeedList.InsertColumn(1, _T("URL"), LVCFMT_LEFT, nColInterval*2);
	m_FeedList.InsertColumn(2, _T("Description"), LVCFMT_LEFT, rect.Width()-4*nColInterval);

	// Extra styles: Full Row Select
    DWORD styles = LVS_EX_FULLROWSELECT | LVS_EX_FLATSB|LVS_EX_HEADERDRAGDROP;
    // Use macro since this is new and not in MFC.
	m_FeedList.SetExtendedStyle(styles);

	// Update Feed List
	UpdateFeedList();
	if(gFeeds.size() > 0)
		gLastFeed = gFeeds[0];
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CManageDlg::UpdateFeedList()
{
	// Load Feeds
	LoadFeeds();
	
	// Clear out old list
	m_FeedList.DeleteAllItems();

	// Repopulate list
	int id = 0;
	for(vector < FEED >::iterator iter = gFeeds.begin(); iter != gFeeds.end(); ++iter)
	{
		m_FeedList.InsertItem(id, iter->title.c_str());
		m_FeedList.SetItem(id, 1, LVIF_TEXT, iter->url.c_str(), 0, 0, 0, 0);
		m_FeedList.SetItem(id, 2, LVIF_TEXT, iter->description.c_str(), 0, 0, 0, 0);

		id++;
	}
}

void CManageDlg::OnClose() 
{
	EndDialog(0);
	
	CDialog::OnClose();
}

void CManageDlg::OnAdd() 
{
	CFeedDialog dlg;

	int result = dlg.DoModal();

	UpdateFeedList();
}

void CManageDlg::OnEdit() 
{
	CFeedDialog dlg;

	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to edit.", "No Selection");
		return;
	}

	if(m_FeedList.GetNextItem(iItem, LVNI_SELECTED) != -1)
	{
		MessageBox("Please select only one RSS Feed to edit.", "Bad Selection");
		return;
	}

	dlg.SetEditMode(iItem);
	int result = dlg.DoModal();

	if(result == 0)
	{
		gFeeds[iItem] = *(gFeeds.end() - 1);
		gFeeds.erase(gFeeds.end() - 1);
		SaveFeeds();
		UpdateFeedList();
	}

	// The item becomes unselected for some reason. Restore selection
	m_FeedList.SetItemState(iItem, LVIS_SELECTED, LVIS_SELECTED);
}

void CManageDlg::OnDelete() 
{
	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to remove.", "No Selection");
		return;
	}

	int result = MessageBox("Are you sure you want to remove those RSS Feeds?\nNote that the feed is only removed from the below listing, it is not removed from sites it has been submitted to.", "Are You Sure?", MB_OKCANCEL);

	if(result == IDCANCEL)
		return;

	while((iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED)) != -1)
	{
		gFeeds.erase(gFeeds.begin() + iItem);
		m_FeedList.DeleteItem(iItem);
	}
	SaveFeeds();
	UpdateFeedList();
}

void CManageDlg::OnKeydownList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;

	if(pLVKeyDow->wVKey == VK_DELETE)
	{
		OnDelete();
	}
	
	*pResult = 0;
}

void CManageDlg::OnPrev() 
{
	EndDialog(1);
}

BOOL CManageDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_ToolTipCtrl.RelayEvent(pMsg);
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CManageDlg::OnFileExit() 
{
	EndDialog(0);
}

void CManageDlg::OnActionBack() 
{
	EndDialog(1);
}

void CManageDlg::OnActionNext() 
{
	EndDialog(2);
}

void CManageDlg::OnFileCheckupdates() 
{
	WinExec("AutoUpdater.exe", SW_SHOW);
}

void CManageDlg::OnLogClearlog() 
{
	ClearLog();
}

void CManageDlg::OnLogViewlog() 
{
	ViewLog();
}
