// ManualSubDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "ManualSubDlg.h"
#include "ProgressDlg.h"
#include <curl.h>
#include "BrowserDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

const char *gManSites[][14] =
{
	// Site Name, Site URL, title, description, url, category, weburl, country, language, name, email, extras, GET? REFERER
	{"Read A Blog", "http://www.readablog.com/AddFeed.aspx", "", "", "template:m_RSSURL", "", "", "", "", "", "", "", 0, ""},
	{"Findory", "http://findory.com/submit-blog/", "", "", "blogxml", "blogcategory", "", "", "", "", "", "submit=1", 0, ""},
	{"Blogarama", "http://www.blogarama.com/index.php?show=add", "blogname", "description", "siteURL", "", "", "country", "", "contact", "email", "add_submit=1&adult=0&passA=RSSANNOUNCER&passB=RSSANNOUNCER", 0, ""},
	{"RSS Network", "http://www.rss-network.com/submitrss.php", "", "", "url", "", "", "", "", "", "", "", 0, ""},
	{"2RSS", "http://www.2rss.com/index.php", "", "description", "url", "category", "", "", "", "", "", "podcast=0&submit=1", 0, ""},
	{"All Headline News", "http://www.allheadlinenews.com/suggestsource.shtml", "publication", "description", "xml", "", "url", "country", "", "name", "email", "redirect=http%3A%2F%2Fwww.allheadlinenews.com%2Fsuggestcomplete.shtml&subject=Newsfeed+Submission+Request&pub_frequency=continuously+&cp_avg=1&artical_avg=daily&requested_category=&Submit=Submit+inclusion+request", 0, ""},
	{"BlogPulse", "http://www.blogpulse.com/submit.html", "", "", "body", "", "", "", "", "", "from", "image.x=20&image.y=12", 0, "http://www.blogpulse.com/submit.html"},
	{"Blog Catalog", "http://www.blogcatalog.com/blogs/submit_blog.html", "b_title", "b_description", "b_url", "b_cat1", "", "b_country", "", "", "b_email", "b_password=RSSANNOUNCER&b_password1=RSSANNOUNCER&b_comments=&b_newsletter=0&b_submit=1", 0, ""},
	{"Bloggernity", "http://www.bloggernity.com/cgi-bin/add.cgi", "Title", "Description", "URL", "", "", "", "", "Contact_Name", "Contact_Email", "", 0, ""},
	{"Newzfire", "http://www.newzfire.com/suggest.aspx", "", "", "FeedTB", "", "", "", "", "", "", "SubmitBtn=Submit&__VIEWSTATE=dDwxOTk2MTA0NzI0O3Q8O2w8aTwxPjs+O2w8dDw7bDxpPDE+O2k8Mz47PjtsPHQ8cDxwPGw8VmlzaWJsZTs+O2w8bzx0Pjs+Pjs+O2w8aTwzPjs+O2w8dDxwPDtwPGw8b25rZXlkb3duOz47bDxmblRyYXBLRCgnU3VibWl0QnRuJyxldmVudCk7Pj4+Ozs+Oz4+O3Q8cDxwPGw8VmlzaWJsZTs+O2w8bzxmPjs+Pjs+Ozs+Oz4+Oz4+Oz6ObTxVJP9+ED7ic4CvbNZCCRXb7w==", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""}
};

/////////////////////////////////////////////////////////////////////////////
// CManualSubDlg dialog


CManualSubDlg::CManualSubDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CManualSubDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManualSubDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CManualSubDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManualSubDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManualSubDlg, CDialog)
	//{{AFX_MSG_MAP(CManualSubDlg)
	ON_WM_TIMER()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManualSubDlg message handlers

map < CString, CString > GetMappedInputs(const char *site[14], FEED feed)
{
	map < CString, CString > res;

	if(site[2][0])
		res[site[2]] = feed.title.c_str();
	if(site[3][0])
		res[site[3]] = feed.description.c_str();
	if(site[4][0])
		res[site[4]] = feed.url.c_str();
	if(site[5][0])
		res[site[5]] = feed.category.c_str();
	if(site[6][0])
		res[site[6]] = feed.weburl.c_str();
	if(site[7][0])
		res[site[7]] = feed.country.c_str();
	if(site[8][0])
		res[site[8]] = feed.language.c_str();
	if(site[9][0])
		res[site[9]] = feed.name.c_str();
	if(site[10][0])
		res[site[10]] = feed.email.c_str();

	return res;
}

void FormatHTML(CString &content, map < CString, CString > inputs)
{
	int pos = 0;

	while(1)
	{
		CString lower = content;
		lower.MakeLower();
		int inpos = lower.Find("<input", pos);
		int texpos = lower.Find("<textarea", pos);
		int begin;

		if(inpos == -1 && texpos == -1)
			break;

		if((inpos < texpos && inpos != -1) || texpos == -1)
			begin = inpos;
		else
			begin = texpos;

		int end = content.Find(">", begin);
		if(end == -1)
		{
			pos = begin + 1;
			continue;
		}

		pos = begin + 1;

		CString peice = content.Mid(begin, end - begin + 1);
		CString lpeice = peice;
		lpeice.MakeLower();

		int name_begin = lpeice.Find("name=\"");
		if(name_begin == -1)
			continue;

		int name_end = lpeice.Find("\"", name_begin + 6);
		if(name_end == -1)
			continue;

		CString name = peice.Mid(name_begin + 6, name_end - name_begin - 6);

		if(inputs.find(name) == inputs.end())
			continue;

		if(lpeice.Left(6) == "<input")
		{
			int value_begin = lpeice.Find("value=\"");
			if(value_begin == -1)
			{
				int insert = peice.GetLength() - 1;
				int slash = lpeice.Find(" /");
				if(slash != -1)
					insert = slash;

				peice.Insert(insert, " value=\"" + inputs[name] + "\" ");
			}
			else
			{
				value_begin += 7;
				int value_end = lpeice.Find("\"", value_begin);
				if(value_end == -1)
					continue;

				peice.Delete(value_begin, value_end - value_begin);
				peice.Insert(value_begin, inputs[name]);
			}
		}
		else
		{
			int text_begin = end + 1;
			int text_end = content.Find("</", text_begin);
			if(text_end == -1)
				continue;

			content.Delete(text_begin, text_end - text_begin);
			content.Insert(text_begin, inputs[name]);
		}

		content.Delete(begin, end - begin + 1);
		content.Insert(begin, peice);
	}
}

void CManualSubDlg::FormatSite()
{
	FILE *fp = fopen("temp.html", "rb");

	if(fp == NULL)
		return;

	CString content;
	char data[1024] = {0};
	int len = 0;
	while((len = fread(data, 1, 1024, fp)) == 1024)
	{
		data[len] = 0;
		content += data;
	}
	data[len] = 0;
	content += data;
	fclose(fp);


	map < CString, CString > inputs = GetMappedInputs(gManSites[gSelectedManEngines[m_CurrentSite]], gSelectedFeeds[m_CurrentFeed]);

	FormatHTML(content, inputs);


	fp = fopen("temp.html", "wb");
	if(fp == NULL)
		return;
	fprintf(fp, "%s", (const char *)content);
	fclose(fp);
}

void CManualSubDlg::NextSite()
{
	CURL *curl;
	FILE *fp;

	m_CurrentSite++;

	if(m_CurrentSite == (signed)gSelectedManEngines.size())
	{
		m_CurrentFeed++;
		if(m_CurrentFeed == (signed)gSelectedFeeds.size())
		{
			EndDialog(2);
			return;
		}
		m_CurrentSite = 0;
	}

	fp = fopen("temp.html", "wb");
	if(!fp)
	{
		MessageBox("Failed to open file for writing.", "Error");
		return;
	}

	fprintf(fp, "<base href=\"%s\">", gManSites[gSelectedManEngines[m_CurrentSite]][1]);

	curl = curl_easy_init();

	curl_easy_setopt(curl, CURLOPT_URL, gManSites[gSelectedManEngines[m_CurrentSite]][1]);
	curl_easy_setopt(curl, CURLOPT_WRITEDATA, fp);
	curl_easy_setopt(curl, CURLOPT_TIMEOUT, 30);
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, fwrite);

	curl_easy_perform(curl);

	fclose(fp);

	FormatSite();


	char dir[1024];
	GetCurrentDirectory(1023, dir);
	CString url;
	url.Format("%s\\temp.html", dir);

	if(gManSites[gSelectedManEngines[m_CurrentSite]][13] == CString("direct"))
		url = gManSites[gSelectedManEngines[m_CurrentSite]][1];

	CBrowserDlg dlg;
	dlg.m_URL = url;
	if(dlg.DoModal() == 2)
	{
		m_CurrentSite = gSelectedManEngines.size();
		EndDialog(1);
	}

	CString log;
	log.Format("Manually Submitted '%s' to '%s'\r\n", gSelectedFeeds[m_CurrentFeed].url.c_str(), gManSites[gSelectedManEngines[m_CurrentSite]][0]);
	AddToLog(log);
}

BOOL CManualSubDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(gSelectedManEngines.size() == 0)
	{
		EndDialog(2);
		return TRUE;
	}

	m_CurrentSite = -1;
	m_CurrentFeed = 0;

	SetTimer(0, 200, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CManualSubDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 0)
	{
		KillTimer(0);
		NextSite();
		SetTimer(0, 200, NULL);
	}
	
	CDialog::OnTimer(nIDEvent);
}

BOOL CManualSubDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, OUR_BGCOLOR);
	return FALSE;
}
