// ProgressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "ProgressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

const char *gSites[][14] =
{
	// Site Name, Site URL, title, description, url, category, weburl, country, language, name, email, extras, GET? REFERER
	{"Yahoo", "http://add.yahoo.com/fast/help/us/my/cgi_rss_submission", "text_input30", "textarea60", "text_input40", "select50", "", "", "", "name", "email", "send=1", 0, ""},
	{"BlogStreet", "http://www.blogstreet.com/bin/addrss.cgi", "", "", "rssurl", "", "", "", "", "", "", "", 0, ""},
	{"Syndic8", "http://www.syndic8.com/suggest.php?Advanced=0&Mode=data", "", "", "URL[0]", "", "", "", "", "", "", "Stage=2&UserID=&URLChecked[]=0", 0, ""},
	{"NewsIsFree", "http://www.newsisfree.com/contact.php", "", "", "comment", "", "", "", "", "realname", "email", "ACTION=post&subject=Suggesting%20a%20new%20source", 0, ""},
	{"DayPop", "http://www.daypop.com/submit_site", "", "", "url", "", "", "", "", "", "", "extra=1&submit=1", "yes", ""},
	{"Feedster", "http://www.feedster.com/add.php", "", "", "rss_url", "", "", "", "", "", "", "ie=ISO-8859-1&hl=en&action=add&btnG=1", "yes", ""},
	{"BlogDex", "http://blogdex.net/add.asp", "", "", "site", "", "", "", "", "", "email", "", 0, ""},
	{"Popdex", "http://www.popdex.com/addsite.php", "blog_name", "", "url", "", "", "", "language", "", "", "linked=1", 0, ""},
	{"Moreover", "http://w.moreover.com/cgi-local/site/sourcesubmission_out.pl", "publication", "description", "xml", "", "url", "country", "", "name", "email", "_send_email=email.txt&Email%20Opt%20Out=no&Submit=1", 0, ""},
	{"RDF-Ticker", "http://www.anse.de/rdfticker/addchannel.php", "title", "description", "feedurl", "", "", "", "language", "", "", "submit=Submit+channel", "yes", ""},
	{"BlogDigger", "http://www.blogdigger.com/add.jsp", "", "", "rss", "", "", "", "", "", "", "submit=Submit", 0, ""},
	{"Bloogz", "http://www.bloogz.com/man_en/add_your_url.php", "", "", "url_submit", "", "", "", "", "", "", "commenti=&Submit=1", 0, ""},
	{"HeadlineSpot", "http://www.headlinespot.com/site/suggest.htm?sendit", "NAME", "BRIEF", "URL", "", "", "", "", "NOMINATOR", "EMAIL_ADDR", "body=.&HEAR=Google&SOURCE=I+made+this+site", 0, ""},
	{"Diarist.net", "http://www.diarist.net/cgi-bin/links/add.cgi", "Title", "Description", "URL", "", "", "Category", "", "Contact%20Name", "Contact%20Email", "Author=Same+as+Contact&Sex=female&bdMonth=01&bdDate=25&bdYear=1970&Author=", 0, ""},
	{"easyRSS", "http://www.easyrss.com/", "", "", "add", "", "", "", "", "", "", "", "yes", ""},
	{"NewsXS", "http://www.newsxs.com/en/sources", "name", "description", "url", "", "", "", "language", "", "email", "type=rss&submit=1&source=new", 0, ""},
	{"Feeds Farm", "http://www.feedsfarm.com/a.html", "", "", "url", "", "", "", "", "lang", "", "isOPML=false", "yes", ""},
	{"Newstrove", "http://www.NewsTrove.com/cgi-bin/suggest_site.pl", "name", "description", "url", "", "", "", "", "", "", "", 0, ""},
	{"Sourceforge", "http://ngoid.sourceforge.net/add_rss.php", "", "", "url", "", "", "", "", "", "", "duration=30", 0, ""},
	{"FeedPlex", "http://www.feedplex.com/suggest-a-feed.php", "", "", "website", "", "", "", "", "", "", "input_form=yes", 0, ""},
	{"Feed Shark", "http://www.feedshark.com/submit.php", "", "", "xmlurl", "category", "", "", "", "", "", "btnSubmit=1", 0, ""},
	{"Blogwise", "http://www.blogwise.com/submit", "", "", "url", "", "", "", "", "name", "email", "", 0, ""},
	{"Boing Boing", "http://www.vex.net/~smith/cgi/mailtobbs.cgi", "subject", "description", "suggested_url", "", "from_url", "", "", "email_name", "email_from", "", 0, "http://boingboing.net/confirm.html"},
	{"Rub Hub", "http://www.rubhub.com/main/add/index.cfm", "", "", "url", "", "", "", "", "", "", "", 0, ""},
	{"Fyber Search", "http://www.fybersearch.com/suggest-a-url.php", "", "", "website", "", "", "", "", "", "email", "add_url_form=yes", 0, ""},
	{"Technorati", "http://www.technorati.com/ping/", "", "", "url", "", "", "", "", "", "", "", "yes", ""},
	{"Postami", "http://www.postami.com/rss.finder/submit_feed.php", "", "", "val_rss", "", "", "", "", "", "", "e=1", 0, ""},
	{"WeBlogALot", "http://www.weblogalot.com/submit.php?module=ping", "", "", "url", "", "", "", "", "", "", "", 0, ""},
	{"Feed24", "http://www.feed24.com/?c=add", "", "", "url", "", "", "", "", "", "", "submit=OK", 0, ""},
	{"Ice Rocket", "http://www.icerocket.com/c", "", "", "rss", "", "", "", "", "", "", "p=addblog", "yes", ""},
	{"Swoogle", "http://swoogle.umbc.edu/modules.php?name=Swoogle_Submission", "", "", "urls", "", "", "", "", "", "", "submitername=&organization=&email=&topics=&comments=&submitted=Submit+URLs", 0, ""},
	{"Blogz", "http://www.sarthak.net/blogz/submit.php?q=&p=add&a=submit", "site_name", "site_description", "site_url", "", "", "", "", "", "", "", 0, ""},
	{"NewsMob", "http://www.newsmob.com/step2.php", "", "", "url", "", "", "", "", "", "", "", "yes", ""},
	{"CompleteRSS", "http://www.completerss.com/AddFeed.aspx", "", "", "txtFeed", "", "", "", "", "", "", "__VIEWSTATE=dDwxNjkwMzQwMzIyO3Q8O2w8aTwwPjtpPDI%2BO2k8ND47PjtsPHQ8O2w8aTwwPjs%2BO2w8dDw7bDxpPDk%2BOz47bDx0PDtsPGk8MD47PjtsPHQ8cDxwPGw8SW1hZ2VVcmw7PjtsPC9pbWFnZXMvZmVlZF9vbl9hbGx0YWJzLmdpZjs%2BPjs%2BOzs%2BOz4%2BOz4%2BOz4%2BO3Q8O2w8aTwxPjs%2BO2w8dDxwPDtwPGw8b25rZXlkb3duOz47bDxmblRyYXBLRChkb2N1bWVudC5hbGwuYnRuU2VhcmNoKTs%2BPj47Oz47Pj47dDw7bDxpPDE%2BOz47bDx0PHA8cDxsPFZpc2libGU7PjtsPG88Zj47Pj47Pjs7Pjs%2BPjs%2BPjtsPGJ0blNlYXJjaDtidG5TdWJtaXQ7Pj64rV3g9EmYHhi4Zm7EC%2FBNr%2F0yUQ%3D%3D&tbSearch=&btnSubmit.x=81&btnSubmit.y=14", 0, ""},
	{"4GuysFromRolla", "http://4guysfromrolla.Aspin.com/func/addres/rss-review/userlist?rid=1427020&proc=getrss&cob=4guysfromrolla", "ResForm_name", "", "ResForm_url", "", "", "", "", "", "", "SubmitProc=getrss", 0, ""},
	{"Feedzie", "http://feedzie.ziecom.com/SuggestFeed.php", "", "", "feedaddress", "", "", "country", "language", "", "contactemail", "additionalgeotag=", 0, ""},
	{"Fastbuzz", "http://www.fastbuzz.com/channels/insert_public.jsp", "", "", "url", "", "", "", "", "", "", "zapatecToken=Insert123456&zapatecActionInsert=Submit", 0, ""},
	{"Loomia", "http://www.loomia.com/addUserFeed", "", "", "state.feed:record", "", "", "", "", "", "", "state.isauthor:record=1", 0, ""},
	{"Truth Laid Bear", "http://www.truthlaidbear.com/addtoscan.php", "weblog_title", "", "weblog_url", "", "", "", "", "", "", "commit=Y", 0, ""},
	{"Rocket Info", "http://reader.rocketinfo.com/desktop/AddRSSFeed.jsp", "feedtitle", "description", "feedurl", "", "", "", "", "contact", "email", "", 0, ""},
	{"Rocket News", "http://www.rocketnews.com/rocket/jsp/SubmitSite.jsp", "", "", "url", "", "", "", "", "", "email", "", 0, ""},
	{"", "", "", "", "", "", "", "", "", "", "", "", 0, ""}
};
// DO NOT FORGET TO UPDATE MAX_SITES

/////////////////////////////////////////////////////////////////////////////
// CProgressDlg dialog


CProgressDlg::CProgressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProgressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProgressDlg)
	//}}AFX_DATA_INIT
	m_Task = 2;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CProgressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProgressDlg)
	DDX_Control(pDX, IDC_PROGRESSCANCEL, m_Cancel);
	DDX_Control(pDX, IDC_TEXTPROGRESS, m_TextProgress);
	DDX_Control(pDX, IDC_CURRENTSITE, m_CurrentSite);
	DDX_Control(pDX, IDC_SITEPROGRESS, m_SiteProgress);
	DDX_Control(pDX, IDC_PROGRESSBAR, m_ProgressBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProgressDlg, CDialog)
	//{{AFX_MSG_MAP(CProgressDlg)
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_PROGRESSCANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProgressDlg message handlers

int gCurrentFeed = 0;
int gCurrentSite = 0;
int gCancel = 0;

UINT ValidateAllThread(LPVOID pParam)
{
	CURL *curl;
	FILE *fp;
	int m_Feed = 0;

	curl = curl_easy_init();

	gCurrentFeed = 0;
	gCurrentSite = 0;

	for(vector<FEED>::iterator iter = gSelectedFeeds.begin(); iter != gSelectedFeeds.end(); ++iter)
	{
		char error[CURL_ERROR_SIZE] = {0};

		if(gCancel)
			break;

		int result = 0;
		CString url = curl_escape(gSelectedFeeds[m_Feed].url.c_str(), 0);
		CString file;
		file.Format("temp%i-0.html", m_Feed);

		curl_easy_reset(curl);

		gCurrentFeed = m_Feed;

		fp = fopen(file, "wb");
		if(fp == NULL)
		{
			MessageBox(NULL, "Could not open file for writing", "", MB_OK);
			break;
		}

		url = "http://feedvalidator.org/check.cgi?url=" + url;
		fprintf(fp, "<base href=\"http://feedvalidator.org/\">\n");
	
		curl_easy_setopt(curl, CURLOPT_URL, (const char *)url);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, fp);
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, fwrite);
		curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, error);
		curl_easy_setopt(curl, CURLOPT_FOLLOWLOCATION, 1);
		curl_easy_setopt(curl, CURLOPT_MAXREDIRS, 1);

		int errorc = curl_easy_perform(curl);
		if(errorc)
			fprintf(fp, "<h1>There was an error:</h1>%s", error);

		fclose(fp);

		// Log the event
		CString log;
		log.Format("Validated %s\r\n", gSelectedFeeds[m_Feed].url.c_str());
		AddToLog(log);

		m_Feed++;
	}

	curl_easy_cleanup(curl);

	return 0;
}

CString FormatPostData(const char *site[14], const char *title, const char *description, const char *url, const char *category, const char *weburl, const char *country, const char *language, const char *name, const char *email)
{
	CString data;

	data.Format("%s=%s&%s=%s&%s=%s&%s=%s&%s=%s&%s=%s&%s=%s&%s=%s&%s=%s&%s",
		site[2], title, site[3], description, site[4], url, site[5], category, site[6], weburl, site[7], country, site[8], language, site[9], name, site[10], email, site[11]);

	while(1)
	{
		int pos = data.Find("&=");
		if(pos == -1)
			break;

		int end = data.Find("&", pos + 1);
		if(end == -1)
			end = data.GetLength();

		data.Delete(pos, end - pos);
	}

	if(data.GetAt(0) == '=')
	{
		int end = data.Find("&");
		if(end == -1)
			end = data.GetLength();

		data.Delete(0, end);
	}

	return data;
}

int GetFeedCategoryID(const char *category)
{
	CString yahoo_cat[] = {"Business & Finance - Employment","Business & Finance - News","Business & Finance - Personal Finance","Business & Finance - Stock Market","Entertainment & Arts - Books & Literature","Entertainment & Arts - Fashion","Entertainment & Arts - Humor & Satire","Entertainment & Arts - Movies","Entertainment & Arts - Music","Entertainment & Arts - News","Entertainment & Arts - Parties","Entertainment & Arts - Performing Arts","Entertainment & Arts - Photography","Entertainment & Arts - TV","Entertainment & Arts - Video Games","Entertainment & Arts - Weblogs","Health & Wellness - Cancer","Health & Wellness - News","Health & Wellness - Personal Health Tools","Health & Wellness - Tips & Advice","Health & Wellness - Weblogs","Internet & Technology - Blogging","Internet & Technology - Mobile Downloads","Internet & Technology - News","Internet & Technology - Personal Information Management","Internet & Technology - Tech Weblogs","Internet & Technology - Web Search","Internet & Technology - Web Site Management","Internet & Technology - Web Sites of the Day","Living & Lifestyles - Astrology","Living & Lifestyles - Charity & Community Service","Living & Lifestyles - Crafts",
		"Living & Lifestyles - Food & Drink","Living & Lifestyles - Home & Garden","Living & Lifestyles - Lesbian, Gay & Bisexual","Living & Lifestyles - Love & Romance","Living & Lifestyles - News","Living & Lifestyles - Parenting","Living & Lifestyles - Pets","Living & Lifestyles - Religion & Spirituality","Living & Lifestyles - Weblogs","Local - Africa","Local - Asia","Local - Australia/New Zealand","Local - Canada","Local - Europe","Local - Latin America","Local - United States","News & Media - Business","News & Media - Entertainment","News & Media - Government","News & Media - Health","News & Media - Living & Lifestyles","News & Media - Magazines","News & Media - Most Popular","News & Media - Opinion & Editorials","News & Media - Photos","News & Media - Politics","News & Media - Regional","News & Media - Science","News & Media - Sports","News & Media - Strange News","News & Media - Technology","News & Media - Top Stories","News & Media - Weather","News & Media - Weblogs","News & Media - World","Politics - News & Media","Politics - Weblogs","Recreation & Travel - Autos","Recreation & Travel - Bicycling","Recreation & Travel - Gambling","Recreation & Travel - Lottery","Recreation & Travel - Ski Reports","Recreation & Travel - Travel","Recreation & Travel - Video Games","Reference - Libraries","Science - News","Science - Weather","Shopping - Shopping","Sports - Auto Racing","Sports - Baseball","Sports - Basketball","Sports - Fantasy Sports","Sports - Football","Sports - Golf","Sports - Hockey","Sports - Tennis","Sports - News","Sports - Scores","Sports - Soccer","Sports - Team Calendars","Sports - Weblogs"
	};

	for(int cate = 0; cate < sizeof(yahoo_cat) / sizeof(CString); cate++)
		if(category == yahoo_cat[cate])
			break;

	if(cate >= sizeof(yahoo_cat) / sizeof(CString))
		cate = 0;

	return cate;
}

UINT SubmitAllThread(LPVOID pParam)
{
	CURL *curl;
	int m_Feed = 0;
	int m_Site = 0;

	curl = curl_easy_init();

	gCurrentFeed = 0;
	gCurrentSite = 0;

	while(1)
	{
		if(gCancel)
			break;

		FILE *fp = NULL;
		int result = 0;
		CString url = curl_escape(gSelectedFeeds[m_Feed].url.c_str(), 0);
		CString name = curl_escape(gSelectedFeeds[m_Feed].name.c_str(), 0);
		CString email = curl_escape(gSelectedFeeds[m_Feed].email.c_str(), 0);
		CString title = curl_escape(gSelectedFeeds[m_Feed].title.c_str(), 0);
		CString category;
		CString description = curl_escape(gSelectedFeeds[m_Feed].description.c_str(), 0);
		CString language = curl_escape(gSelectedFeeds[m_Feed].language.c_str(), 0);
		CString country = curl_escape(gSelectedFeeds[m_Feed].country.c_str(), 0);
		CString weburl = curl_escape(gSelectedFeeds[m_Feed].weburl.c_str(), 0);
		CString submit_url = gSites[gSelectedEngines[m_Site]][1];
		CString file;
		if(gSites[gSelectedEngines[m_Site]][0] == CString("Yahoo"))
		{
			int cate = GetFeedCategoryID(gSelectedFeeds[m_Feed].category.c_str());
			category.Format("opt50%i", cate + 1);
		}
		else
		{
			category = curl_escape(gSelectedFeeds[m_Feed].category.c_str(), 0);
		}

		file.Format("temp%i-%i.html", m_Feed, m_Site);
		fp = fopen(file, "wb");
		if(fp == NULL)
		{
			MessageBox(NULL, "Could not open file for writing", "", MB_OK);
			break;
		}

		CString post_data = FormatPostData(gSites[gSelectedEngines[m_Site]], title, description, url, category, weburl, country, language, name, email);

		fprintf(fp, "<base href=\"%s\">\n", (const char *)submit_url);

		curl_easy_reset(curl);
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, fp);
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, fwrite);
		curl_easy_setopt(curl, CURLOPT_TIMEOUT, 30);
		curl_easy_setopt(curl, CURLOPT_REFERER, gSites[gSelectedEngines[m_Site]][13]);
		// If uses GET
		if(gSites[gSelectedEngines[m_Site]][12])
			submit_url += "?" + post_data;
		else
			curl_easy_setopt(curl, CURLOPT_POSTFIELDS, (const char *)post_data);
		curl_easy_setopt(curl, CURLOPT_URL, (const char *)submit_url);

		gCurrentFeed = m_Feed;
		gCurrentSite = m_Site;

		curl_easy_perform(curl);
		fclose(fp);

		// Log the event
		CString log;
		log.Format("Submitted '%s' to '%s'\r\n", gSelectedFeeds[m_Feed].url.c_str(), gSites[gSelectedEngines[m_Site]][0]);
		AddToLog(log);

		m_Site++;
		if(m_Site == (signed)gSelectedEngines.size())
		{
			m_Feed++;
			m_Site = 0;
		}

		if(m_Feed == (signed)gSelectedFeeds.size())
			break;
	}

	curl_easy_cleanup(curl);

	return 0;
}

BOOL CProgressDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Set title
	SetWindowText(gProgramName);

    // Set Colors
	m_TextProgress.SetBkColor(OUR_BGCOLOR);
	m_TextProgress.SetTextColor(RGB(255, 255, 255));
	m_CurrentSite.SetBkColor(OUR_BGCOLOR);
	m_CurrentSite.SetTextColor(RGB(255, 255, 255));
	m_ProgressBar.SendMessage(PBM_SETBARCOLOR, 0, RGB(102, 204, 102));
	m_ProgressBar.SendMessage(PBM_SETBKCOLOR, 0, RGB(255, 255, 255));
	m_SiteProgress.SendMessage(PBM_SETBARCOLOR, 0, RGB(102, 204, 102));
	m_SiteProgress.SendMessage(PBM_SETBKCOLOR, 0, RGB(255, 255, 255));

	if(gSelectedEngines.size() == 0 && m_Task == 2)
	{
		EndDialog(2);
		return TRUE;
	}

	m_ProgressBar.SetRange(0, gSelectedFeeds.size());
	m_ProgressBar.SetStep(1);
	m_SiteProgress.SetRange(0, gSelectedEngines.size());
	m_SiteProgress.SetStep(1);

	CString temp;
	temp.Format("Working on feed 1 of %i...", gSelectedFeeds.size());
	m_TextProgress.SetWindowText(temp);
	UpdateData(FALSE);

	gCancel = 0;

	if(m_Task == 1)
		m_Thread = AfxBeginThread(ValidateAllThread, 0, THREAD_PRIORITY_NORMAL, 0, 0, NULL);
	else
		m_Thread = AfxBeginThread(SubmitAllThread, 0, THREAD_PRIORITY_NORMAL, 0, 0, NULL);

	SetTimer(0, 100, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CProgressDlg::ValidateAll()
{
	m_Task = 1;
}

void CProgressDlg::SubmitAll()
{
	m_Task = 2;
}

void CProgressDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 0)
	{
		CString temp;
		m_ProgressBar.SetPos(gCurrentFeed);
		m_SiteProgress.SetPos(gCurrentSite);
		temp.Format("Working on feed %i of %i...", gCurrentFeed + 1, gSelectedFeeds.size());
		m_TextProgress.SetWindowText(temp);
		if(gCancel)
			temp = "Cancelling...";
		else if(m_Task == 2)
			temp.Format("Submitting to %s...", gSites[gSelectedEngines[gCurrentSite]][0]);
		else
			temp = "Submitting to Feed Validator...";
		m_CurrentSite.SetWindowText(temp);
		UpdateData(FALSE);

		DWORD status = 0;
		GetExitCodeThread(m_Thread->m_hThread, &status);
		if(status != STILL_ACTIVE)
		{
			if(gCancel)
				EndDialog(1);
			else
				EndDialog(2);
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CProgressDlg::OnClose() 
{
	EndDialog(0);
	
	CDialog::OnClose();
}

BOOL CProgressDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, OUR_BGCOLOR);  // some color
	return FALSE;
}

void CProgressDlg::OnCancel() 
{
	gCancel = 1;
}
