// RSSSubmitDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "RSSSubmitDlg.h"
#include "FeedDialog.h"
#include "FeedFunctions.h"
#include <comutil.h>
#include <curl.h>
#include <stdio.h>
#include "SplashDlg.h"
#include "ResultsDlg.h"
#include "ProgressDlg.h"
#include "ManualSubDlg.h"

using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSSubmitDlg dialog

CRSSSubmitDlg::CRSSSubmitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSSSubmitDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSSSubmitDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSSSubmitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSSSubmitDlg)
	DDX_Control(pDX, IDC_FEEDLIST, m_FeedList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSSSubmitDlg, CDialog)
	//{{AFX_MSG_MAP(CRSSSubmitDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnAddFeed)
	ON_BN_CLICKED(IDC_BUTTON2, OnEditFeed)
	ON_BN_CLICKED(IDC_BUTTON4, OnRemoveFeed)
	ON_BN_CLICKED(IDC_BUTTON3, OnValidate)
	ON_BN_CLICKED(IDC_BUTTON6, OnSubmit)
	ON_WM_DESTROY()
	ON_NOTIFY(LVN_KEYDOWN, IDC_FEEDLIST, OnKeydownFeedlist)
	ON_BN_CLICKED(IDC_BUTTON5, OnValidateAll)
	ON_BN_CLICKED(IDC_BUTTON7, OnSubmitAll)
	ON_BN_CLICKED(IDC_MANUALSUBMIT, OnManualSubmit)
	ON_BN_CLICKED(IDC_CHECKUPDATE, OnCheckupdate)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSSSubmitDlg message handlers

BOOL CRSSSubmitDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Add Columns to List Control
	CRect rect;
	m_FeedList.GetClientRect(&rect);
	int nColInterval = rect.Width()/5;

	m_FeedList.InsertColumn(0, _T("Title"), LVCFMT_LEFT, nColInterval*2);
	m_FeedList.InsertColumn(1, _T("URL"), LVCFMT_LEFT, nColInterval*2);
	m_FeedList.InsertColumn(2, _T("Description"), LVCFMT_LEFT, rect.Width()-4*nColInterval);

	// Extra styles: Full Row Select
    DWORD styles = LVS_EX_FULLROWSELECT | LVS_EX_FLATSB|LVS_EX_HEADERDRAGDROP;
    // Use macro since this is new and not in MFC.
	m_FeedList.SetExtendedStyle(styles);

	// Update Feed List
	UpdateFeedList();

	// Initalize cURL
	m_curl = curl_easy_init();

	if(gFeeds.size() > 0)
		gLastFeed = gFeeds[0];

	// Init CURL
	curl_global_init(CURL_GLOBAL_WIN32);

	// Display splash screen
	CSplashDlg dlg;
	dlg.DoModal();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSSSubmitDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSSSubmitDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSSSubmitDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSSSubmitDlg::OnAddFeed() 
{
	CFeedDialog dlg;

	int result = dlg.DoModal();

	UpdateFeedList();
}

void CRSSSubmitDlg::UpdateFeedList()
{
	// Load Feeds
	LoadFeeds();
	
	// Clear out old list
	m_FeedList.DeleteAllItems();

	// Repopulate list
	int id = 0;
	for(vector < FEED >::iterator iter = gFeeds.begin(); iter != gFeeds.end(); ++iter)
	{
		m_FeedList.InsertItem(id, iter->title.c_str());
		m_FeedList.SetItem(id, 1, LVIF_TEXT, iter->url.c_str(), 0, 0, 0, 0);
		m_FeedList.SetItem(id, 2, LVIF_TEXT, iter->description.c_str(), 0, 0, 0, 0);

		id++;
	}
}

void CRSSSubmitDlg::OnEditFeed() 
{
	CFeedDialog dlg;

	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to edit.", "No Selection");
		return;
	}

	if(m_FeedList.GetNextItem(iItem, LVNI_SELECTED) != -1)
	{
		MessageBox("Please select only one RSS Feed to edit.", "Bad Selection");
		return;
	}

	dlg.SetEditMode(iItem);
	int result = dlg.DoModal();

	if(result == 0)
	{
		gFeeds[iItem] = *(gFeeds.end() - 1);
		gFeeds.erase(gFeeds.end() - 1);
		SaveFeeds();
		UpdateFeedList();
	}

	// The item becomes unselected for some reason. Restore selection
	m_FeedList.SetItemState(iItem, LVIS_SELECTED, LVIS_SELECTED);
}


// TODO: Modify to handle multiple selection
void CRSSSubmitDlg::OnRemoveFeed()
{
	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to remove.", "No Selection");
		return;
	}

	int result = MessageBox("Are you sure you want to remove those RSS Feeds?\nNote that the feed is only removed from the below listing, it is not removed from sites it has been submitted to.", "Are You Sure?", MB_OKCANCEL);

	if(result == IDCANCEL)
		return;

	while((iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED)) != -1)
	{
		gFeeds.erase(gFeeds.begin() + iItem);
		m_FeedList.DeleteItem(iItem);
	}
	SaveFeeds();
	UpdateFeedList();
}

void CRSSSubmitDlg::OnValidate()
{
	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to validate.", "No Selection");
		return;
	}

	gSelectedFeeds.clear();
	gSelectedFeeds.push_back(gFeeds[iItem]);

	while((iItem = iItem = m_FeedList.GetNextItem(iItem, LVNI_SELECTED)) != -1)
		gSelectedFeeds.push_back(gFeeds[iItem]);

	DoProgressDialog(0);
}

//TODO: Check user info to make sure there's some...
void CRSSSubmitDlg::OnSubmit() 
{
	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to submit.", "No Selection");
		return;
	}

	gSelectedFeeds.clear();
	gSelectedFeeds.push_back(gFeeds[iItem]);

	while((iItem = iItem = m_FeedList.GetNextItem(iItem, LVNI_SELECTED)) != -1)
		gSelectedFeeds.push_back(gFeeds[iItem]);

	DoProgressDialog(1);
}

void CRSSSubmitDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	curl_global_cleanup();
}

void CRSSSubmitDlg::OnKeydownFeedlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here

	if(pLVKeyDow->wVKey == VK_DELETE)
	{
		OnRemoveFeed();
	}
	
	*pResult = 0;
}

void CRSSSubmitDlg::OnValidateAll() 
{
	if(gFeeds.size() == 0)
	{
		MessageBox("There are no feeds to validate.", "Error");
		return;
	}

	gSelectedFeeds = gFeeds;

	DoProgressDialog(0);
}

void CRSSSubmitDlg::OnOK()
{

}

void CRSSSubmitDlg::OnSubmitAll() 
{
	if(gFeeds.size() == 0)
	{
		MessageBox("There are no feeds to submit.", "Error");
		return;
	}

	gSelectedFeeds = gFeeds;

	DoProgressDialog(1);
}

void CRSSSubmitDlg::DoProgressDialog(int type)
{
	CProgressDlg pdlg;

	if(type)
		pdlg.SubmitAll();
	else
		pdlg.ValidateAll();
	int result = pdlg.DoModal();

	if(result == 1)
	{
		CResultsDlg dlg;

		dlg.SetResults(gSelectedFeeds);
		if(type)
			dlg.m_Sites = MAX_SITES;
		else
			dlg.m_Sites = 1;
		dlg.DoModal();
	}
}

void CRSSSubmitDlg::OnManualSubmit() 
{
	int iItem = m_FeedList.GetNextItem(-1, LVNI_SELECTED);

	if(iItem == -1)
	{
		MessageBox("You need to select a RSS Feed to submit.", "No Selection");
		return;
	}

	gSelectedFeeds.clear();
	gSelectedFeeds.push_back(gFeeds[iItem]);

	while((iItem = iItem = m_FeedList.GetNextItem(iItem, LVNI_SELECTED)) != -1)
		gSelectedFeeds.push_back(gFeeds[iItem]);

	if(gSelectedFeeds.size() > 1)
	{
		MessageBox("You must select only one RSS Feed for Manual Submission.", "Selection Error");
		return;
	}

	CManualSubDlg pdlg;

	int result = pdlg.DoModal();
}

void CRSSSubmitDlg::OnCheckupdate() 
{
	WinExec("AutoUpdater.exe", SW_SHOW);
}

BOOL CRSSSubmitDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, RGB(99,117,214));  // some color
	return FALSE;
	return CDialog::OnEraseBkgnd(pDC);
}
