// ResultsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSSSubmit.h"
#include "ResultsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResultsDlg dialog


CResultsDlg::CResultsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResultsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResultsDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CResultsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResultsDlg)
	DDX_Control(pDX, IDC_RESULTSPREV, m_Prev);
	DDX_Control(pDX, IDC_PAGESLIDER, m_PageSlider);
	DDX_Control(pDX, IDC_CSTATIC, m_CStatic);
	DDX_Control(pDX, IDC_RESULTLIST, m_List);
	DDX_Control(pDX, IDC_RESULTVIEW, m_ResultView);
	DDX_Control(pDX, IDC_PAGENOTE, m_PageNote);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CResultsDlg, CDialog)
	//{{AFX_MSG_MAP(CResultsDlg)
	ON_NOTIFY(NM_CLICK, IDC_RESULTLIST, OnClickResultlist)
	ON_NOTIFY(LVN_ODSTATECHANGED, IDC_RESULTLIST, OnOdstatechangedResultlist)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_PAGESLIDER, OnReleasedcapturePageslider)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_RESULTLIST, OnItemchangedResultlist)
	ON_WM_ERASEBKGND()
	ON_BN_CLICKED(IDC_RESULTSPREV, OnPrev)
	ON_WM_CLOSE()
	ON_COMMAND(ID_ACTION_BACK, OnActionBack)
	ON_COMMAND(ID_FILE_CHECKUPDATES, OnFileCheckupdates)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_LOG_CLEARLOG, OnLogClearlog)
	ON_COMMAND(ID_LOG_VIEWLOG, OnLogViewlog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResultsDlg message handlers

void CResultsDlg::OnClickResultlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateSelection();
	
	*pResult = 0;
}

BOOL CResultsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Tool Tips
	m_ToolTipCtrl.Create(this);
	m_ToolTipCtrl.AddTool(&m_Prev, "Back");
	m_ToolTipCtrl.AddTool(&m_PageSlider, "Slide To Select Different Pages");

	// Menu
	CMenu *menu = GetMenu();
	menu->RemoveMenu(ID_ACTION_NEXT, MF_BYCOMMAND);
	menu->RemoveMenu(ID_ACTION_VALIDATE, MF_BYCOMMAND);

	// Set colors
	m_PageNote.SetBkColor(OUR_BGCOLOR);
	m_PageNote.SetTextColor(RGB(255, 255, 255));
	m_CStatic.SetBkColor(OUR_BGCOLOR);
	m_CStatic.SetTextColor(RGB(255, 255, 255));
	m_PageSlider.SetBkColor(OUR_BGCOLOR);
	m_PageSlider.SetTextColor(RGB(255, 255, 255));

	CRect rect;
	m_List.GetClientRect(&rect);
	int nColInterval = rect.Width()/5;

	m_List.InsertColumn(0, _T("Title"), LVCFMT_LEFT, nColInterval*2);
	m_List.InsertColumn(1, _T("URL"), LVCFMT_LEFT, nColInterval*2);
	m_List.InsertColumn(2, _T("Description"), LVCFMT_LEFT, rect.Width()-4*nColInterval);

	// Clear out old list
	m_List.DeleteAllItems();

	if(gSelectedEngines.size() > 0)
		SetResults(gSelectedFeeds);

	// Repopulate list
	int id = 0;
	for(std::vector < FEED >::iterator iter = Feeds.begin(); iter != Feeds.end(); ++iter)
	{
		m_List.InsertItem(id, iter->title.c_str());
		m_List.SetItem(id, 1, LVIF_TEXT, iter->url.c_str(), 0, 0, 0, 0);
		m_List.SetItem(id, 2, LVIF_TEXT, iter->description.c_str(), 0, 0, 0, 0);

		id++;
	}

	// Extra styles: Full Row Select
    DWORD styles = LVS_EX_FULLROWSELECT;
    // Use macro since this is new and not in MFC.
	m_List.SetExtendedStyle(styles);

	// Create Browser
	m_ResultView.CreateFromControl(this, IDC_RESULTVIEW);

	if(gDisplayValidation)
		m_Sites = 1;
	else
		m_Sites = gSelectedEngines.size();

	m_PageSlider.SetRange(0, m_Sites - 1);
	m_PageSlider.SetPos(0);
	m_PageSlider.SetPageSize(1);
	CString temp;
	temp.Format("Viewing Page %i of %i", 1, m_Sites);
	m_PageNote.SetWindowText(temp);

	m_List.SetItemState(0, LVIS_SELECTED, LVIS_SELECTED);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CResultsDlg::SetResults(std::vector < FEED > feeds)
{
	Feeds = feeds;
}

void CResultsDlg::OnOdstatechangedResultlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NMLVODSTATECHANGE* pStateChanged = (NMLVODSTATECHANGE*)pNMHDR;


	
	*pResult = 0;
}

void CResultsDlg::OnReleasedcapturePageslider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateSelection();
	
	*pResult = 0;
}

void CResultsDlg::UpdateSelection()
{
	int iItem = m_List.GetNextItem(-1, LVNI_SELECTED);

	if(iItem != -1)
	{
		int site = m_PageSlider.GetPos();
		char dir[1024];
		CString temp;
		GetCurrentDirectory(1023, dir);

		temp.Format("%s/temp%i-%i.html", dir, iItem, site);

		m_ResultView.Navigate(temp);

		CString ptemp;
		ptemp.Format("Viewing Page %i of %i", site + 1, m_Sites);
		m_PageNote.SetWindowText(ptemp);
	}
}

void CResultsDlg::OnItemchangedResultlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	UpdateSelection();
	*pResult = 0;
}

BOOL CResultsDlg::OnEraseBkgnd(CDC* pDC) 
{
	CRect rect;
	GetClientRect(&rect);
	pDC->FillSolidRect(&rect, OUR_BGCOLOR);  // some color
	return FALSE;
}

void CResultsDlg::OnPrev() 
{
	EndDialog(1);
}

BOOL CResultsDlg::PreTranslateMessage(MSG* pMsg) 
{
	m_ToolTipCtrl.RelayEvent(pMsg);
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CResultsDlg::OnClose() 
{
	EndDialog(0);
	
	CDialog::OnClose();
}

void CResultsDlg::OnActionBack() 
{
	EndDialog(1);
}

void CResultsDlg::OnFileCheckupdates() 
{
	WinExec("AutoUpdater.exe", SW_SHOW);
}

void CResultsDlg::OnFileExit() 
{
	EndDialog(0);
}

void CResultsDlg::OnLogClearlog() 
{
	ClearLog();
}

void CResultsDlg::OnLogViewlog() 
{
	ViewLog();	
}
